#include "windows.h"
#include "windowsx.h"
#include "taskbaricon.h"

CTaskbarIcon::CTaskbarIcon(HWND hwnd,UINT id,UINT msg,HICON icon,LPSTR tip)
{
	ZeroMemory(&m_data,sizeof(NOTIFYICONDATA));
	m_data.cbSize = sizeof(NOTIFYICONDATA);
	m_show = FALSE;
	if(hwnd != NULL){
		Create(hwnd,id,msg,icon,tip);
		Add();
	}
}

CTaskbarIcon::~CTaskbarIcon()
{
	if(m_show)Delete();
}

BOOL CTaskbarIcon::Create(HWND hwnd,UINT id,UINT msg,HICON icon,LPSTR tip)
{
	if(m_show)Delete();

	m_data.hWnd = hwnd;
	m_data.uID = id;
	m_data.uFlags = ((msg != 0) ? NIF_MESSAGE : 0) | ((icon != NULL) ? NIF_ICON : 0) | ((tip != NULL) ? NIF_TIP : 0);
	m_data.uCallbackMessage = msg;
	m_data.hIcon = icon;
	if(tip != NULL){
		lstrcpy(m_data.szTip,tip);
	}else{
		lstrcpy(m_data.szTip,"");
	}
	return TRUE;
}
BOOL CTaskbarIcon::Add()
{
	if(m_show)return Modify();

	if(Shell_NotifyIcon(NIM_ADD,&m_data)){
		m_show = TRUE;
		return TRUE;
	}
	return FALSE;
}

BOOL CTaskbarIcon::Delete()
{
	if(Shell_NotifyIcon(NIM_DELETE,&m_data)){
		m_show = FALSE;
		return TRUE;
	}
	return FALSE;
}

BOOL CTaskbarIcon::Modify()
{
	if(m_show)
		return Shell_NotifyIcon(NIM_MODIFY,&m_data);
	else
		return Add();
}

BOOL CTaskbarIcon::SetMessage(UINT msg,BOOL refresh)
{
	if(msg == 0){
		m_data.uFlags = m_data.uFlags & (!NIF_MESSAGE);
	}else{
		m_data.uFlags |= NIF_MESSAGE;
		m_data.uCallbackMessage = msg;
	}
	if(refresh)Modify();
	return TRUE;
}

HICON CTaskbarIcon::SetIcon(HICON icon,BOOL refresh)
{
	HICON old = m_data.hIcon;
	if(icon == NULL){
		m_data.uFlags = m_data.uFlags & (!NIF_ICON);
	}else{
		m_data.uFlags |= NIF_ICON;
		m_data.hIcon = icon;
	}
	if(refresh)Modify();
	return old;
}

BOOL CTaskbarIcon::SetTip(LPSTR tip,BOOL refresh)
{

	int i;
	if(tip == NULL){
		m_data.uFlags = m_data.uFlags & (!NIF_TIP);
	}else{
		m_data.uFlags |= NIF_TIP;
		for(i=0;i<64;i++)if(tip[i]!='\0')m_data.szTip[i]=tip[i];
		m_data.szTip[i]='\0';
		//lstrcpy(m_data.szTip,tip);
	}
	if(refresh)Modify();
	return TRUE;
}
